// In_mpg123dParam.h: CIn_mpg123dParam NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_IN_MPG123DPARAM_H__D62BDF71_F32C_4E8A_96CD_BE403E63F4D0__INCLUDED_)
#define AFX_IN_MPG123DPARAM_H__D62BDF71_F32C_4E8A_96CD_BE403E63F4D0__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "SIFInfo.h"
#include "ICYInfo.h"

class CIn_mpg123dParam : public CObject
{
public:
	CIn_mpg123dParam();
	virtual ~CIn_mpg123dParam();

	void GetProfile(void);
	void WriteProfile(void);
	void GetIniFn(HMODULE hDllInstance);
	void URLDecode(char* src, char* dst);
	int GetPriorityValue(int n);

	char ini_file[MAX_PATH];

	CSIFInfo m_sif;
	CICYInfo m_icy;

	// CStreamingDialog
	int m_nBufferLength;
	BOOL	m_bProxy;
	CString	m_strProxy;
	BOOL	m_bSaveStream;
	CString	m_strSaveStream;
	BOOL	m_bTitleStreaming;
	BOOL	m_bTitleStreamingDecode;
	BOOL	m_bTitleStreamingUDP;
	CString	m_strTitleStreamingFormat;

	// CFormatDialog
	CString m_strID3Format;
	CString m_strSIFFormat;

	// CConfigDialog
	BOOL	m_bEnable;
	BOOL	m_bSupZero;
	BOOL	m_bForce;
	BOOL	m_bDispAvg;
	BOOL	m_bAltVolume;
	BOOL	m_bReverse;
	BOOL	m_bInvert;
	BOOL	m_bFullBuffering;
	int		m_nOutputBps;

	BOOL m_bPostProc;

	// CGeneralDialog
	BOOL	m_nUseMP3;
	BOOL	m_nUseRMP;
	BOOL	m_nUseWAV;
	CString m_strAdditionalExtension;

	// etc.
	int m_nVolume;
	int m_nPan;

	int m_nStartPage;


	int m_nTimeOut;
	int m_nReceiveThreadPriority;
	int m_nDecodeThreadPriority;
	int m_nInetReadThreadPriority;

private:
	char x2c(char *what);



};

typedef struct ThreadParam {
  volatile BOOL kill;
  HANDLE Thread;
  CWinThread* mt;
  CIn_mpg123dParam* param;
} THREADPARAM;


#endif // !defined(AFX_IN_MPG123DPARAM_H__D62BDF71_F32C_4E8A_96CD_BE403E63F4D0__INCLUDED_)
